// gcc -Wall -O3 numeric.c -o numeric -lm && ./numeric && rm numeric

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define N 102400000
#define REPS 10

double *do_calc(double *arr) {
    double *result = malloc(N * sizeof(double));
    for( int i=0; i<N; i++ ) {
        result[i] = sin(arr[i] - 1) + 1;
    }
    return result;
}

int main() {
    double *arr = malloc(N * sizeof(double));
    double *result;
    clock_t st, en;
    int i;

    /* fill the array */
    srand((unsigned int)time(NULL));
    for( i=0; i<N; i++ ) {
        arr[i] = (double)rand()/(double)(RAND_MAX) * M_2_PI;
    }
    
    /* do the calculation */
    st = clock();
    for( i=0; i<REPS; i++ ) {
        result = do_calc(arr);
        free(result);
    }
    en = clock();
    printf("C do_calc: %f seconds\n", (double)(en - st) / CLOCKS_PER_SEC / REPS);
    free(arr);
}
